{*******************************************************}
{                                                       }
{       SoftReal TAPI Components demo                   }
{                                                       }
{       Copyright (c) 2002-2004 SoftReal Kft.           }
{       All rights reserved.                            }
{                                                       }
{       Version:      V1.1 R2                           }
{       Compiler:     Delphi 5                          }
{       System:       Windows 98, Me, NT4, 2K, XP       }
{       Programmers:  2002 L.G.Horvath                  }
{                     2004 L.G.Horvath                  }
{       E-mail:       softreal@softreal.hu              }
{                                                       }
{*******************************************************}

unit Main;

{ The main form defined in this unit does almost everything. }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, SrTapi, Soros32, Contnrs;

type
  TComBuf = class(TObject)
  private
    FSent: Boolean;
    FBuf: PByteArray;
    FSize: Integer;
  public
    constructor Create(ASent: Boolean; const Msg: array of Byte);
    destructor Destroy; override;
    property Buf: PByteArray read FBuf;
    property Sent: Boolean read FSent;
    property Size: Integer read FSize;
  end;

  TMainForm = class(TForm)
    PageControl1: TPageControl;
    Panel1: TPanel;
    TabSheet1: TTabSheet;
    Label2: TLabel;
    ApiVersionEdit: TEdit;
    TabSheet2: TTabSheet;
    MsgMemo: TMemo;
    Panel3: TPanel;
    ExitButton: TButton;
    StartButton: TButton;
    StopButton: TButton;
    DeviceListView: TListView;
    Label1: TLabel;
    Label3: TLabel;
    ModemEdit: TEdit;
    OpenLineButton: TButton;
    CloseLineButton: TButton;
    ConfigButton: TButton;
    CallButton: TButton;
    DestAddrEdit: TEdit;
    Label4: TLabel;
    DropButton: TButton;
    Panel2: TPanel;
    ClearMsgButton: TButton;
    Label5: TLabel;
    CommNameEdit: TEdit;
    Label6: TLabel;
    SendReceiveTabSheet: TTabSheet;
    ComPort: TCom32Port;
    Label8: TLabel;
    TabSheet4: TTabSheet;
    ComEdit: TEdit;
    BaudComboBox: TComboBox;
    Label7: TLabel;
    Label9: TLabel;
    CommNameEdit2: TEdit;
    Label10: TLabel;
    CommNameEdit3: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    OpenComButton: TButton;
    CloseComButton: TButton;
    ComMemo: TMemo;
    ClearComButton: TButton;
    SendEdit: TEdit;
    Label13: TLabel;
    GroupBox1: TGroupBox;
    AsciiRadioButton: TRadioButton;
    RadioButton2: TRadioButton;
    Mask7CheckBox: TCheckBox;
    AddCRLFCheckBox: TCheckBox;
    Label14: TLabel;
    GroupBox2: TGroupBox;
    DtrCheckBox: TCheckBox;
    RtsEnableRadioButton: TRadioButton;
    RtsHandshakeRadioButton: TRadioButton;
    RtsDisableRadioButton: TRadioButton;
    RtsToggleRadioButton: TRadioButton;
    Label15: TLabel;
    SendButton: TButton;
    Service: TTapiLineService;
    Label16: TLabel;
    ByteSizeComboBox: TComboBox;
    Label17: TLabel;
    ParityComboBox: TComboBox;
    Label18: TLabel;
    StopBitsComboBox: TComboBox;
    AcceptButton: TButton;
    Label19: TLabel;
    CallerIDEdit: TEdit;
    GroupBox3: TGroupBox;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    ReadMultiplierEdit: TEdit;
    WriteMultiplierEdit: TEdit;
    Label20: TLabel;
    ReadConstantEdit: TEdit;
    WriteConstantEdit: TEdit;
    ReadIntervalEdit: TEdit;
    SetTimeoutsButton: TButton;
    Label25: TLabel;
    GetCallerIDButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExitButtonClick(Sender: TObject);
    procedure ServiceMessage(hDevice, dwMsg, dwCallbackInstance,
      dwParam1, dwParam2, dwParam3: Cardinal);
    procedure StartButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure DeviceListViewSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure OpenLineButtonClick(Sender: TObject);
    procedure CloseLineButtonClick(Sender: TObject);
    procedure ConfigButtonClick(Sender: TObject);
    procedure CallButtonClick(Sender: TObject);
    procedure DropButtonClick(Sender: TObject);
    procedure ClearMsgButtonClick(Sender: TObject);
    procedure ComPortReadReady(Sender: TObject; ByteCount: Integer);
    procedure ComPortWriteReady(Sender: TObject; ByteCount: Integer);
    procedure ComEditChange(Sender: TObject);
    procedure OpenComButtonClick(Sender: TObject);
    procedure CloseComButtonClick(Sender: TObject);
    procedure BaudComboBoxChange(Sender: TObject);
    procedure ClearComButtonClick(Sender: TObject);
    procedure SendEditKeyPress(Sender: TObject; var Key: Char);
    procedure SendReceiveTabSheetShow(Sender: TObject);
    procedure ComLogModeClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DtrCheckBoxClick(Sender: TObject);
    procedure RtsDisableRadioButtonClick(Sender: TObject);
    procedure RtsEnableRadioButtonClick(Sender: TObject);
    procedure RtsHandshakeRadioButtonClick(Sender: TObject);
    procedure RtsToggleRadioButtonClick(Sender: TObject);
    procedure SendButtonClick(Sender: TObject);
    procedure ByteSizeComboBoxChange(Sender: TObject);
    procedure ParityComboBoxChange(Sender: TObject);
    procedure StopBitsComboBoxChange(Sender: TObject);
    procedure AcceptButtonClick(Sender: TObject);
    procedure SetTimeoutsButtonClick(Sender: TObject);
    procedure GetCallerIDButtonClick(Sender: TObject);
  private
    FLine: TTapiLineDevice;
    FReadBuf: array [0..32767] of Byte;
    FWriteBuf: array [0..32767] of Byte;
    FComLogHex: Boolean;
    FComLogMask7: Boolean;
    FComMemoObjs: TObjectList;
    procedure ShowError(const Msg: string);
    procedure ShowService;
    procedure ShowComm(Sender: TObject);
    procedure LineClose(Sender: TObject);
    procedure LineCallConnected(Sender: TObject; CommHandle: THandle;
        const CommName, ErrorMsg: string);
    procedure LineCallDisconnected(Sender: TObject);
    procedure LineCallError(Sender: TObject; Code: Cardinal);
    procedure LineCallID(Sender: TObject;
        const CallerID: string; Flag: Cardinal);
    procedure LineCallOffering(Sender: TObject;
        const CallerID: string; Flag: Cardinal);
    procedure LineCallState(Sender: TObject; State, Info, Priv: Cardinal);
    procedure LineCallFinished(Sender: TObject);
    procedure DropCall;
    procedure LogMsg(const Msg: string);
    procedure LogCom(Sent: Boolean; const Msg: array of Byte);
    function BufToStr(MaskTo7Bits: Boolean; const Buf: array of Byte): string;
    procedure StrToBuf(Ascii, AppendCrLf: Boolean; const Str: string;
        Buf: PByteArray; var Count: Integer);
    function ComBufToStr(Buf: TComBuf): string;
    procedure EnableSend(Enable: Boolean);
    procedure ComLogModeChange;
  public
  end;

var
  MainForm: TMainForm;

implementation

uses DispCall;

{$R *.DFM}

{ TMainForm }

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ComMemo.Clear;
  FComMemoObjs:= TObjectList.Create;
  ShowService;
  ShowComm(Self);
  AsciiRadioButton.Checked:= True;  // FComLogHex = False, FComLogMask7 = False
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FComMemoObjs.Free;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  try
    ComPort.CloseLine;
    Service.Active:= False;
  except
    on E: Exception do ShowError(E.Message);
  end;
end;

procedure TMainForm.ShowError(const Msg: string);
begin
  LogMsg(Msg);
  Application.MessageBox(PChar(Msg), PChar('Error'), MB_ICONERROR or MB_OK);
end;

procedure TMainForm.ServiceMessage(hDevice, dwMsg, dwCallbackInstance,
  dwParam1, dwParam2, dwParam3: Cardinal);
begin
  LogMsg(FormatLineMessage(hDevice, dwMsg, dwCallbackInstance,
      dwParam1, dwParam2, dwParam3));
end;

procedure TMainForm.ShowService;
var
  I: Integer;
  Dev: TTapiLineDevice;
begin
  ApiVersionEdit.Text:= tapiVersionToStr(Service.ApiVersion);
  DeviceListView.Items.Clear;
  ModemEdit.Text:= '';
  for I:= 0 to Service.DeviceCount - 1 do begin
    Dev:= Service.Device[I];
    with DeviceListView.Items.Add do begin
      Caption:= Dev.Name;
      Data:= Dev;
      SubItems.Add(IntToStr(Dev.ID));
      SubItems.Add(tapiVersionToStr(Dev.ApiVersion));
      SubItems.Add(Dev.DeviceClasses.CommaText);
    end;
  end;
end;

procedure TMainForm.ShowComm(Sender: TObject);
var
  S: string;
begin
  if ComPort.ComOpen then S:= ComPort.ComName else S:= '';
  CommNameEdit.Text:= S;
  CommNameEdit2.Text:= S;
  CommNameEdit3.Text:= S;
  ComEdit.Enabled:= not ComPort.ComOpen;
  if Sender <> ComEdit then ComEdit.Text:= ComPort.ComName;
  BaudComboBox.Enabled:= not ComPort.ComOpen;
  if Sender <> BaudComboBox then BaudComboBox.Text:= IntToStr(ComPort.BaudRate);
  ByteSizeComboBox.Enabled:= not ComPort.ComOpen;
  ByteSizeComboBox.ItemIndex:= ByteSizeComboBox.Items.IndexOf(IntToStr(ComPort.ByteSize));
  ParityComboBox.Enabled:= not ComPort.ComOpen;
  ParityComboBox.ItemIndex:= ComPort.Parity;
  StopBitsComboBox.Enabled:= not ComPort.ComOpen;
  StopBitsComboBox.ItemIndex:= ComPort.StopBits;
  DtrCheckBox.Enabled:= not ComPort.ComOpen;
  DtrCheckBox.Checked:= ComPort.RtsCts;
  RtsDisableRadioButton.Enabled:= not ComPort.ComOpen;
  RtsHandshakeRadioButton.Enabled:= not ComPort.ComOpen;
  RtsEnableRadioButton.Enabled:= not ComPort.ComOpen;
  RtsToggleRadioButton.Enabled:= not ComPort.ComOpen;
  if not ComPort.RtsCts or ComPort.UserRts then
    RtsDisableRadioButton.Checked:= True
  else if ComPort.ModemHandshake then
    RtsHandshakeRadioButton.Checked:= True
  else if ComPort.Modem then
    RtsEnableRadioButton.Checked:= True
  else
    RtsToggleRadioButton.Checked:= True;
  OpenComButton.Enabled:= not ComPort.ComOpen;
  CloseComButton.Enabled:= ComPort.ComOpen;
  SetTimeoutsButton.Enabled:= ComPort.ComOpen;
  if not ComPort.ComOpen then
    EnableSend(False);  // Open and WriteReady will enable, WriteBytes will disable
end;

procedure TMainForm.DeviceListViewSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if Assigned(Item) and Selected and Assigned(Item.Data)
      and TTapiLineDevice(Item.Data).IsDataModem then
    ModemEdit.Text:= TTapiLineDevice(Item.Data).Name
  else
    ModemEdit.Text:= '';
end;

procedure TMainForm.ExitButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.StartButtonClick(Sender: TObject);
begin
  try
    Service.Active:= True;
    StartButton.Enabled:= False;
    StopButton.Enabled:= True;
  except
    on E: Exception do ShowError(E.Message);
  end;
  ShowService;
end;

procedure TMainForm.StopButtonClick(Sender: TObject);
begin
  try
    Service.Active:= False;
    LineClose(Self);
    StartButton.Enabled:= True;
    StopButton.Enabled:= False;
  except
    on E: Exception do ShowError(E.Message);
  end;
  ShowService;
end;

procedure TMainForm.OpenLineButtonClick(Sender: TObject);
begin
  try
    if ModemEdit.Text = '' then raise Exception.Create('No modem selected.');
    FLine:= Service.DeviceByName[ModemEdit.Text];
    if not Assigned(FLine) then raise Exception.Create('Line device not found.');
    LogMsg('Line activation initiated');
    FLine.OnClose:= LineClose;
    FLine.OnCallConnected:= LineCallConnected;
    FLine.OnCallDisconnected:= LineCallDisconnected;
    FLine.OnCallError:= LineCallError;
    FLine.OnCallID:= LineCallID;
    FLine.OnCallOffering:= LineCallOffering;
    FLine.OnCallState:= LineCallState;
    FLine.OnCallFinished:= LineCallFinished;
    FLine.Active:= True;
    OpenLineButton.Enabled:= False;
    CloseLineButton.Enabled:= True;
  except
    on E: Exception do begin
      ShowError(E.Message);
      FLine:= nil;
    end;
  end;
end;

procedure TMainForm.CloseLineButtonClick(Sender: TObject);
begin
  try
    if not Assigned(FLine) then raise Exception.Create('No open line device.');
    LogMsg('Line deactivation initiated');
    FLine.Active:= False;
    LineClose(FLine);
  except
    on E: Exception do ShowError(E.Message);
  end;
end;

procedure TMainForm.LineClose(Sender: TObject);
begin
  if Sender is TTapiLineDevice then TTapiLineDevice(Sender).OnClose:= nil;
  FLine:= nil;
  OpenLineButton.Enabled:= True;
  CloseLineButton.Enabled:= False;
end;

procedure TMainForm.ConfigButtonClick(Sender: TObject);
var
  Dev: TTapiLineDevice;
begin
  try
    if ModemEdit.Text = '' then raise Exception.Create('No modem selected.');
    Dev:= Service.DeviceByName[ModemEdit.Text];
    if not Assigned(Dev) then raise Exception.Create('Line device not found.');
    Dev.ModemConfigDialog;
  except
    on E: Exception do ShowError(E.Message);
  end;
end;

procedure TMainForm.CallButtonClick(Sender: TObject);
var
  R: Integer;
begin
  try
    if not Assigned(FLine) then raise Exception.Create('No open line device.');
    LogMsg('MakeCall initiated');
    FLine.MakeCall(DestAddrEdit.Text);
    CallButton.Enabled:= False;
    LogMsg(DispCallForm.StartCall(DestAddrEdit.Text));
    R:= DispCallForm.ShowModal;
    if R = mrAbort then DropCall
    else if R = mrCancel then begin
      DropButton.Enabled:= True;
      PageControl1.ActivePage:= SendReceiveTabSheet;
    end;
    Update;
  except
    on E: Exception do ShowError(E.Message);
  end;
end;

procedure TMainForm.DropButtonClick(Sender: TObject);
begin
  AcceptButton.Enabled:= False;
  CallerIDEdit.Text:= '';
  try
    if not Assigned(FLine) then raise Exception.Create('No open line device.');
    DropCall;
  except
    on E: Exception do ShowError(E.Message);
  end;
end;

procedure TMainForm.AcceptButtonClick(Sender: TObject);
var
  R: Integer;
begin
  AcceptButton.Enabled:= False;
  try
    if not Assigned(FLine) then raise Exception.Create('No open line device.');
    DropButton.Enabled:= False;
    FLine.AnswerCall;
    R:= DispCallForm.ShowModal;
    if R = mrAbort then DropCall
    else if R = mrCancel then begin
      DropButton.Enabled:= True;
      PageControl1.ActivePage:= SendReceiveTabSheet;
    end;
    Update;
  except
    on E: Exception do ShowError(E.Message);
  end;
end;

procedure TMainForm.GetCallerIDButtonClick(Sender: TObject);
var
  CallerID: string;
  Flag: Cardinal;
begin
  try
    if not Assigned(FLine) then raise Exception.Create('No open line device.');
    FLine.GetCallerID(CallerID, Flag);
    LogMsg(DispCallForm.StartCall(CallerID, Flag, False));
    CallerIDEdit.Text:= CallerID;
  except
    on E: Exception do ShowError(E.Message);
  end;
end;

procedure TMainForm.DropCall;
begin
  if ComPort.ComOpen then begin
    LogMsg('Comm. close initiated');
    ComPort.CloseLine;
    LogMsg('Comm. close finished');
  end;
  LogMsg('DropCall initiated');
  FLine.DropCall;
  LogMsg('DropCall started');
end;

procedure TMainForm.LineCallError(Sender: TObject; Code: Cardinal);
begin
  ShowError(tapiErrorToStr(Code));
end;

procedure TMainForm.LineCallState(Sender: TObject; State, Info, Priv: Cardinal);
begin
  LogMsg(DispCallForm.CallState(State, Info, Priv));
end;

procedure TMainForm.LineCallOffering(Sender: TObject; const CallerID: string;
  Flag: Cardinal);
begin
  LogMsg(DispCallForm.StartCall(CallerID, Flag, True));
  CallButton.Enabled:= False;
  DropButton.Enabled:= True;
  GetCallerIDButton.Enabled:= True;
  AcceptButton.Enabled:= True;
  CallerIDEdit.Text:= CallerID;
end;

procedure TMainForm.LineCallID(Sender: TObject; const CallerID: string;
  Flag: Cardinal);
begin
  LogMsg(DispCallForm.StartCall(CallerID, Flag, False));
  CallerIDEdit.Text:= CallerID;
end;

procedure TMainForm.LineCallFinished(Sender: TObject);
begin
  LogMsg(DispCallForm.EndCall);
  ComPort.CloseLine;
  ShowComm(Self);
  CallButton.Enabled:= True;
  DropButton.Enabled:= False;
  AcceptButton.Enabled:= False;
  GetCallerIDButton.Enabled:= False;
  CallerIDEdit.Text:= '';
end;

procedure TMainForm.LineCallConnected(Sender: TObject; CommHandle: THandle;
  const CommName, ErrorMsg: string);
begin
  if ErrorMsg <> '' then ShowError(ErrorMsg)
  else begin
    try
      ComPort.CloseLine;  // direct cable comm. may have opened
      ComPort.OpenLine(CommHandle, CommName);
      SetTimeoutsButtonClick(Self);
      EnableSend(True);
      ComPort.ReadBytes(FReadBuf, SizeOf(FReadBuf));
    except
      on E: Exception do ShowError(E.Message);
    end;
    ShowComm(Self);
  end;
end;

procedure TMainForm.LineCallDisconnected(Sender: TObject);
begin
  try
    DropCall;
  except
    on E: Exception do ShowError(E.Message);
  end;
  ShowComm(Self);
end;

procedure TMainForm.ComPortReadReady(Sender: TObject; ByteCount: Integer);
begin
  LogMsg(Format('ComPortReadReady = %d', [ByteCount]));
  if ByteCount < 0 then begin
    LogMsg(SysErrorMessage(ComPort.ReadResult));
    // You mustn't close ComPort right here, because it would cause a dead-lock.
    // Comm. error is always caused by a call state change, it will be handled later.
  end else begin
    if ByteCount > 0 then LogCom({Sent:}False, Slice(FReadBuf, ByteCount));
    try
      ComPort.ReadBytes(FReadBuf, SizeOf(FReadBuf));
    except
      on E: Exception do ShowError(E.Message);
    end;
  end;
end;

procedure TMainForm.ComPortWriteReady(Sender: TObject; ByteCount: Integer);
begin
  LogMsg(Format('ComPortWriteReady = %d', [ByteCount]));
  if ByteCount < 0 then begin
    LogMsg(SysErrorMessage(ComPort.WriteResult));
    // You mustn't close ComPort right here, because it would cause a dead-lock.
    // Comm. error is always caused by a call state change, it will be handled later.
  end else
    EnableSend(True);
end;

procedure TMainForm.LogMsg(const Msg: string);
begin
  MsgMemo.Lines.Add(DateTimeToStr(Now) + '   ' + Msg);
end;

procedure TMainForm.ClearMsgButtonClick(Sender: TObject);
begin
  MsgMemo.Clear;
end;

procedure TMainForm.ComEditChange(Sender: TObject);
begin
  ComPort.ComName:= ComEdit.Text;
  ShowComm(Sender);
end;

procedure TMainForm.BaudComboBoxChange(Sender: TObject);
begin
  try
    ComPort.BaudRate:= StrToInt(BaudComboBox.Text);
    ShowComm(Sender);
  except
  end;
end;

procedure TMainForm.ByteSizeComboBoxChange(Sender: TObject);
begin
  try
    ComPort.ByteSize:= StrToInt(ByteSizeComboBox.Text);
    ShowComm(Sender);
  except
  end;
end;

procedure TMainForm.ParityComboBoxChange(Sender: TObject);
begin
  try
    ComPort.Parity:= ParityComboBox.ItemIndex;
    ShowComm(Sender);
  except
  end;
end;

procedure TMainForm.StopBitsComboBoxChange(Sender: TObject);
begin
  try
    ComPort.StopBits:= StopBitsComboBox.ItemIndex;
    ShowComm(Sender);
  except
  end;
end;

procedure TMainForm.DtrCheckBoxClick(Sender: TObject);
begin
  ComPort.RtsCts:= DtrCheckBox.Checked;
  ShowComm(Sender);
end;

procedure TMainForm.RtsDisableRadioButtonClick(Sender: TObject);
begin
  if ComPort.RtsCts then begin
    ComPort.UserRts:= True;
    ShowComm(Sender);
  end;
end;

procedure TMainForm.RtsEnableRadioButtonClick(Sender: TObject);
begin
  ComPort.Modem:= True;
  ComPort.ModemHandshake:= False;
  ShowComm(Sender);
end;

procedure TMainForm.RtsHandshakeRadioButtonClick(Sender: TObject);
begin
  ComPort.ModemHandshake:= True;
  ShowComm(Sender);
end;

procedure TMainForm.RtsToggleRadioButtonClick(Sender: TObject);
begin
  ComPort.RtsCts:= True;
  ComPort.UserRts:= False;
  ComPort.Modem:= False;
end;

procedure TMainForm.OpenComButtonClick(Sender: TObject);
begin
  try
    ComPort.ComOpen:= True;
    if not ComPort.ComOpen then
      raise Exception.Create('COM file open error: ' + SysErrorMessage(GetLastError));
    // V1.1 R2: Windows 98 / Me will truncate transmitted buffer to the
    // serial driver's internal buffer size:
    if not SetupComm(ComPort.Handle, SizeOf(FReadBuf), SizeOf(FWriteBuf)) then
      raise Exception.Create('SetupComm failed');
    SetTimeoutsButtonClick(Self);
    EnableSend(True);
    ComPort.ReadBytes(FReadBuf, SizeOf(FReadBuf));
    PageControl1.ActivePage:= SendReceiveTabSheet;
  except
    on E: Exception do ShowError(E.Message);
  end;
  ShowComm(Sender);
end;

procedure TMainForm.CloseComButtonClick(Sender: TObject);
begin
  ComPort.ComOpen:= False;
  if ComPort.ComOpen then
    ShowError('COM file close error: ' + SysErrorMessage(GetLastError));
  ShowComm(Sender);
end;

procedure TMainForm.SetTimeoutsButtonClick(Sender: TObject);
begin
  try
    ComPort.SetComTimeouts(StrToInt(ReadIntervalEdit.Text),
        StrToInt(ReadMultiplierEdit.Text), StrToInt(ReadConstantEdit.Text),
        StrToInt(WriteMultiplierEdit.Text), StrToInt(WriteConstantEdit.Text));
  except
    on E: Exception do ShowError(E.Message);
  end;
  ShowComm(Self);
end;

procedure TMainForm.EnableSend(Enable: Boolean);
begin
  if Enable then begin
    SendButton.Enabled:= True;
    SendEdit.Enabled:= True;
    SendEdit.Color:= clWindow;
    if SendReceiveTabSheet.Visible then FocusControl(SendEdit);
  end else begin
    SendButton.Enabled:= False;
    SendEdit.Enabled:= False;
    SendEdit.Color:= Color;
  end;
end;

procedure TMainForm.SendReceiveTabSheetShow(Sender: TObject);
begin
  if SendEdit.Enabled then FocusControl(SendEdit);
end;

procedure TMainForm.SendEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Ord(Key) = VK_RETURN then begin
    Key:= #0;
    SendButtonClick(Sender);
  end;
end;

procedure TMainForm.SendButtonClick(Sender: TObject);
var
  Count: Integer;
begin
  StrToBuf(AsciiRadioButton.Checked, AddCRLFCheckBox.Checked,
      SendEdit.Text, @FWriteBuf, Count);
  if Count > 0 then begin
    ComPort.WriteBytes(FWriteBuf, Count);
    SendEdit.Clear;
    EnableSend(False);
    LogCom({Sent:}True, Slice(FWriteBuf, Count));
  end else
    EnableSend(True);
end;

procedure TMainForm.ComLogModeClick(Sender: TObject);
begin
  ComLogModeChange;
  AddCRLFCheckBox.Enabled:= AsciiRadioButton.Checked;
  if SendEdit.Enabled then EnableSend(True);  // focus
end;

procedure TMainForm.ComLogModeChange;
var
  Buf: array [0..1023] of Byte;
  I, Count: Integer;
begin
  if (FComLogHex <> not AsciiRadioButton.Checked)
      or (FComLogMask7 <> Mask7CheckBox.Checked) then begin
    FComLogHex:= not AsciiRadioButton.Checked;
    FComLogMask7:= Mask7CheckBox.Checked;
    with ComMemo.Lines do
      for I:= 0 to Count - 1 do
        Strings[I]:= ComBufToStr(TComBuf(FComMemoObjs[I]));
    StrToBuf(FComLogHex, {AppendCrLf:}False, SendEdit.Text, @Buf, Count);
    SendEdit.Text:= BufToStr({MaskTo7bits:}False, Slice(Buf, Count));
  end;
end;

procedure TMainForm.LogCom(Sent: Boolean; const Msg: array of Byte);
var
  B: TComBuf;
begin
  B:= TComBuf.Create(Sent, Msg);
  ComMemo.Lines.Add(ComBufToStr(B));
  FComMemoObjs.Add(B);
end;

procedure TMainForm.ClearComButtonClick(Sender: TObject);
begin
  ComMemo.Clear;
  FComMemoObjs.Clear;  // owns objects
end;

{ The following StrToList function has been copied here from the SoftReal Library
  for your convenience. }

{ StrToList creates a string list from the substrings of the List string.
  Substrings are separated with the Separator string. If Count > 0 then
  the result list will contain exactly that number of items, the missing
  substrings are substituted with empty items, or the last item will contain
  all the remaining part of the List string. If QuotationMark is not a null
  character (#0) then (some of) the substrings may be quoted (e.g.
  'Quoted1',Part2,'Quoted3',Part4). A quoted substring may contain any
  characters including separator characters, furthermore a quoted substring
  will keep leading and trailing space characters. QuotationMark may not be
  a part of Separator or space and may not be used within the quoted substring.
  If FilterTabs parameter is set then each #9 character will be replaced
  by a space before parsing.
  Note: No efforts has been made to filter out syntax errors in the parsed
  string. A syntactically wrong string may still result a correct list. }

function StrToList(const List, Separator: string; Count: Integer = 0;
    QuotationMark: Char = #0; FilterTabs: Boolean = False): TStrings;
var
  S: string;
  P: Integer;

  function Quoted: Boolean;
  var
    P1: Integer;
  begin
    Result:= False;
    if (QuotationMark = #0) or (S[1] <> QuotationMark) then Exit;
    P1:= Pos(QuotationMark, Copy(S, 2, Length(S)));
    if P1 < 1 then Exit;  // quotation is not terminated
    P:= Pos(Separator, Copy(S, P1 + 2, Length(S)));
    if P >= 1 then begin
      Result:= True;
      Inc(P, P1);  //  P = position of separator - 1
    end;
  end;

  function Quotation(const S: string): string;
  begin
    Result:= Trim(S);
    if (QuotationMark <> #0) and (Length(Result) >= 2)
        and (Result[1] = QuotationMark)
        // if Count > 0 then last item may contain more than one quotation:
        and (Pos(QuotationMark, Copy(Result, 2, Length(Result)- 1)) = Length(Result) - 1) then
      Result:= Copy(Result, 2, Length(Result) - 2);
  end;

begin
  Result:= TStringList.Create;  // not sorted
  S:= List;
  if FilterTabs then
    S:= StringReplace(S, #9, ' ', [rfReplaceAll]);
  S:= Trim(S);
  while S <> '' do begin
    if not Quoted then P:= Pos(Separator, S) - 1;
    if (P < 0) or ((Count > 0) and (Result.Count >= Count - 1)) then
      P:= Length(S);
    Result.Add(Quotation(Copy(S, 1, P)));
    Delete(S, 1, P + Length(Separator));
    S:= Trim(S);
  end;
  while Result.Count < Count do Result.Add('');
end;

procedure TMainForm.StrToBuf(Ascii, AppendCrLf: Boolean; const Str: string;
  Buf: PByteArray; var Count: Integer);
var
  S: string;
  I: Integer;
  L: TStrings;
begin
  Count:= 0;
  S:= Trim(Str);
  if Length(S) > 0 then begin
    if Ascii then begin
      if AppendCrLf then S:= S + #13#10;
      Count:= Length(S);
      Move(S[1], Buf[0], Count);
    end else begin
      L:= StrToList(S, ' ');
      try
        Count:= L.Count;
        for I:= 0 to Count - 1 do
          Buf[I]:= StrToInt('$' + L[I]);
      finally
        L.Free;
      end;
    end;
  end;
end;

function TMainForm.BufToStr(MaskTo7Bits: Boolean; const Buf: array of Byte): string;
var
  I: Integer;
  Ch: Byte;
begin
  if AsciiRadioButton.Checked then begin
    SetLength(Result, SizeOf(Buf));
    for I:= 0 to High(Buf) do begin
      Ch:= Buf[I];
      if MaskTo7Bits then Ch:= Ch and $7F;
      if Ch < Ord(' ') then Ch:= Ord('.');
      Result[1 + I]:= Char(Ch);
    end;
  end else begin
    Result:= '';
    for I:= 0 to High(Buf) do begin
      Ch:= Buf[I];
      if MaskTo7Bits then Ch:= Ch and $7F;
      Result:= Result + IntToHex(Ch, 2) + ' ';
    end;
  end;
end;

function TMainForm.ComBufToStr(Buf: TComBuf): string;
const
  SSent: array [Boolean] of string[1] = ('<', '>');
begin
  Result:= SSent[Buf.Sent] + BufToStr(Mask7CheckBox.Checked, Slice(Buf.Buf^, Buf.Size));
end;

{ TComBuf }

constructor TComBuf.Create(ASent: Boolean; const Msg: array of Byte);
begin
  inherited Create;
  FSent:= ASent;
  FSize:= SizeOf(Msg);
  GetMem(FBuf, FSize);
  Move(Msg[0], FBuf[0], FSize);
end;

destructor TComBuf.Destroy;
begin
  FreeMem(FBuf);
  inherited;
end;

end.
