{*******************************************************}
{                                                       }
{       SoftReal TAPI Components demo                   }
{                                                       }
{       Copyright (c) 2002-2004 SoftReal Kft.           }
{       All rights reserved.                            }
{                                                       }
{       Version:      V1.1 R2                           }
{       Compiler:     Delphi 5                          }
{       System:       Windows 98, Me, NT4, 2K, XP       }
{       Programmers:  2002 L.G.Horvath                  }
{                     2004 L.G.Horvath                  }
{       E-mail:       softreal@softreal.hu              }
{                                                       }
{*******************************************************}

(*
This application utilizes {TTapiLineService} and {TCom32Port} components
and shows the cooperation of the components when handling data-modem calls.
Opening the line directly the modem can be controlled by AT commands.

Along with the application you will also get the complete source "as is",
without any further support. The two SoftReal library components has been put
on the main form at design time, if they are not available on your component
palette then they will be removed by Delphi IDE when opening the form,
and furthermore you will be unable to recompile the application.

This demo is free for download.
You may retrieve the latest version of this demo at the SoftReal home page,
located at http://www.softreal.hu/dnload/srtapi_en.shtml#tapiapp.


V1.1 R2 (February 19, 2004):
Send and receive buffer size has been incremented to 32K. Also, a SetupComm
call has been added to TMainForm.OpenComButtonClick to adjust the serial
driver's internal buffers to the user buffers' size (Windows 98/Me requires).


V1.1 R1 (December 10, 2002):
TTapiLineDevice is now capable of answering incoming calls.

The new OnCallOffering event handler is defined for notifying the application
about an incoming call, along with the caller address (if available).
The new AnswerCall method may be used for answering the call.
LINECALLSTATE_OFFERING call state is now converted by tapiCallStateToStr
(this state is passed by OnCallState before the call to OnCallOffering).

Note: Since many current modems offer support for Caller ID, but virtually
every modem disables Caller ID as the default, you may want to use
an additional setup string to enable caller ID.
Try AT+CLIP=1 command for GSM modems, AT#CLS=8#CID=1 for voice modems
and AT#CID=1 (or AT#CID=2, AT%CCID=1, AT%CCID=2, AT+VCID=1, AT#CC1, AT*ID)
for all other modems to get a caller ID string from the modem
along with the first RING string (the string will look like
DATE = 1205 TIME = 1845 NMBR = 1234567 or CLIP: "1234567" - anyhow,
it's the modem driver's business).


V1.0 R1 (December 23, 2002):
The first release of this module.
*)

program TapiApp;

uses
  Forms,
  Main in 'Main.pas' {MainForm},
  DispCall in 'DispCall.pas' {DispCallForm};

{$R *.RES}

begin
  Application.Initialize;
  Application.Title := 'TAPI demo';
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TDispCallForm, DispCallForm);
  Application.Run;
end.
